package ch.unige.solidify.controller;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;

import ch.unige.solidify.model.Module;
import ch.unige.solidify.rest.ActionName;
import ch.unige.solidify.service.MessageService;

public abstract class ModuleController {

  protected List<ControllerWithHateoasHome> resourceList;

  protected String root;
  private final String name;
  @Autowired
  MessageService messageService;

  protected ModuleController(String name) {
    this.name = name;
    this.root = name.toLowerCase();
    this.resourceList = new ArrayList<>();
  }

  public void addResource(ControllerWithHateoasHome r) {
    this.resourceList.add(r);
  }

  public String getName() {
    return this.name;
  }

  public String getRoot() {
    return this.root;
  }

  public List<ControllerWithHateoasHome> getRourceList() {
    return this.resourceList;
  }

  @GetMapping
  public HttpEntity<Module> home() {
    final Module mod = new Module(this.getName());
    mod.add(linkTo(methodOn(this.getClass()).home()).withSelfRel());
    for (final ControllerWithHateoasHome r : this.resourceList) {
      mod.add(linkTo(methodOn(r.getClass()).home()).withRel(ActionName.RESOURCES));
    }
    return new ResponseEntity<>(mod, HttpStatus.OK);
  }

}
